<template>
  <rui-form cancellable
            submit-button-icon="pencil"
            :submit-button-title="$t('js.patches.virtual_patch_selector.submit')"
            :disable-submit="incompleteForm"
            @submit.prevent="validate"
            @cancel="$emit('cancel')">
    <h2>{{ $t('js.patches.virtual_patch_selector.select_patch') }}</h2>
    <rui-empty v-if="virtualPatches.length === 0" :content="$t('js.patches.virtual_patch_selector.no_virtual_patches')" />
    <rui-list-item v-for="patch in virtualPatches"
                   :key="patch.id"
                   class="-clickable"
                   :active="selectedPatch?.id === patch.id"
                   :caption="patch.displayName"
                   icon="virtual"
                   @choose="selectedPatch = patch" />

    <h2>{{ $t('js.patches.virtual_patch_selector.select_shape') }}</h2>
    <rui-toolbar block>
      <rui-button block
                  icon="circle"
                  :active="selectedShape === 'Circle'"
                  :caption="$t('js.patches.virtual_patch_selector.circle')"
                  @click="selectedShape = 'Circle'" />
      <rui-button block
                  icon="polygon"
                  :active="selectedShape === 'Polygon'"
                  :caption="$t('js.patches.virtual_patch_selector.polygon')"
                  @click="selectedShape = 'Polygon'" />
    </rui-toolbar>
  </rui-form>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

export default {
  name: 'GpaVirtualPatchSelectorForm',
  emits: [
    'validate',
    'cancel',
  ],
  components: { RuiButton, RuiToolbar, RuiListItem, RuiEmpty, RuiForm },
  data () {
    return {
      selectedPatch: null,
      selectedShape: null,
    }
  },
  computed: {
    virtualPatches () { return this.$store.getters.virtualPatches },
    incompleteForm () { return !this.selectedPatch || !this.selectedShape },
  },
  methods: {
    validate () {
      this.$emit('validate', {
        patch: this.selectedPatch,
        shape: this.selectedShape,
      })
    },
  },
}
</script>
